% skript for demonstration of variational integrators
% created by Claude Gittelson

% mathematical pendulum ode and Lagrangian
ode = odeOsc([0 1.6]', [0 8]);
L = @(q, v) 1/2*v.*v + cos(q);

% choose some some step size
h = 2^-5;

% define methods
exampleMethods;

% define discrete Lagrangian for Verlet
L_trap = @(q0, q1) h/2*L(q0,1/h*(q1-q0))+h/2*L(q1,1/h*(q1-q0));

% calculate variations of discrete action for Verlet
varAction(verlet, ode, L_trap, h);
varAction(trapez, ode, L_trap, h);
varAction(impMidpnt, ode, L_trap, h);

% a shortcoming of this demonstration
varAction(sympEuler, ode, L_trap, h);

% repeat for implicit midpoint
L_mid = @(q0, q1) h*L(1/2*(q0+q1),1/h*(q1-q0));
varAction(impMidpnt, ode, L_mid, h);
varAction(verlet, ode, L_mid, h);
varAction(rkGauss(4), ode, L_mid, h);