function ode = odeOsc(y0, T)
%ODEOSC Oscillator, mathematical pendulum
%  ODE = ODEOSC(Y0, T)

% created by Claude Gittelson

y0(1) = rem(y0(1),pi);

ode = odeParams(@f, @Df, y0, T, 'Pendulum', @vis);


% --------------------------------------------------------------------------

function dydt = f(t,y)
dydt = [    y(2) 
         -sin(y(1)) ]; 

% --------------------------------------------------------------------------

function dfdy = Df(t,y)
dfdy = [     0         1
         -cos(y(1))    0 ];

     
% -------------------------------------------------------------------------

function [] = vis(sol, varargin)

sol.y(1,:) = mod(sol.y(1,:)+pi,2*pi)-pi;

plot(sol.y(1,:), sol.y(2,:), varargin{:});
xlabel('q');
ylabel('p');