function adjoint = rkAdjoint(mtd)
%RKADJOINT adjoint of rk method

% created by Claude Gittelson

c = zeros(size(mtd.c));
A = zeros(size(mtd.A));
b = zeros(size(mtd.b));

for i=1:length(c)
    c(i) = 1 - mtd.c(mtd.s+1-i);
end

for i=1:length(b)
    b(i) = mtd.b(mtd.s+1-i);
    for j=1:length(c)
        A(i,j) = mtd.b(mtd.s+1-j) - mtd.A(mtd.s+1-i,mtd.s+1-j);
    end
end

name = sprintf('adjoint of %s', mtd.name);

adjoint = rkParams(c, A, b, name);
