function adjoint = rkCompAdjoint(mtd)
%RKCOMPADJOINT adjoint of composition rk method

% created by Claude Gittelson

method = mtd.method;
weight = mtd.weight;

s = length(weight);

for i=1:s
    weight(i) = mtd.weight(s+1-i);
    mtdi = mtd.method(s+1-i);
    method(i) = mtdi.adjoint(mtdi);
end

name = sprintf('adjoint of %s', mtd.name);

adjoint = rkCompParams(method, weight, name);
    
