function mtd = rkGauss(p)
%RKGAUSS Gauss methods of order p = 2, 4, 6

% created by Claude Gittelson

switch p
    case 2 % implicit midpoint rule
        mtd = rkParams([0.5],[0.5],[1],'Gauss(2)');

    case 4
        mtd = rkParams([0.5-sqrt(3)/6  0.5+sqrt(3)/6],...
            [     0.25        0.25-sqrt(3)/6
              0.25+sqrt(3)/6      0.25       ],...
            [0.5  0.5],...
            'Gauss(4)');

    case 6
        mtd = rkParams([0.5-sqrt(15)/10  0.5  0.5+sqrt(15)/10],...
            [     5/36            2/9-sqrt(15)/15    5/36-sqrt(15)/30
              5/36+sqrt(15)/24          2/9          5/36-sqrt(15)/24
              5/36+sqrt(15)/30    2/9+sqrt(15)/15          5/36       ],...
            [5/18  4/9  5/18],...
            'Gauss(6)');
end
