function param = rkPartParams(mtd1, mtd2, name)
%RKPARTPARAMS create parameters for rkPart

% created by Claude Gittelson

if(mtd1.s ~= mtd2.s)
    return;
end

param.s = mtd1.s;

param.mtd1 = mtd1;
param.mtd2 = mtd2;

param.name = 'Partitioned RK Method';
if(nargin>=3)
    if(ischar(name))
        param.name = name;
    end
end

% implementation of adjoint
% syntax: adjointMtd = mtd.adjoint(mtd);

param.adjoint = @(varargin) rkPartAdjoint(param, varargin{:});

% implementation of rk solver
param.step = @rkPartStep;
param.solver = @rk;
param.solve = @(varargin) rk(param, varargin{:});
